<template>
<div>
  <st-search
    md="12"
    text="Buscar por nombre o código"
    @enter="searchCoor($event)"
  />
  <st-select-table
    :dataInfo="{ headers,items,key }"
    :loading="loading"
    @selected="captureCoor($event)"
  />
  <div class="items-box">
    <div v-if="coor">
      <v-btn small text @click="deleteCoor()">X</v-btn>
      {{ coor.nombres }}
    </div>
  </div>
  <div class="content-footer">
    <st-secondary-btn nombre="Cancelar" @click="$emit('cancel')"/>
    <st-primary-btn 
    :nombre="!data ? 'Registrar' : 'Actualizar'" 
    :disable="!valid"
    :loading="loadingPost" 
    @click="goNext()"
    />
  </div>
</div>
</template>

<script>
import Search from '@/components/Search'
import SelectTable from '@/components/SelectTable'

export default {
  props:{
    data: Object
  },
  data () {
    return{
      headers: [
        {
          text: 'Nombre',
          align: 'start',
          value: 'nombres',
        },
        {
          text: 'Código',
          value: 'codigo'
        },
      ],
      key: 'idCoordinador',
      items:[],
      coor:null,
      loading: false,
      loadingPost: false,
    }
  },
  mounted(){
    if(this.data){
      let data = this.data
      let coor = {
        idCoordinador: data.coordinador.id,
        nombres: data.coordinador.value
      }
      this.coor = coor
    }
  },
  components:{
    'st-search': Search,
    'st-select-table': SelectTable,
  },
  methods: {
    goNext(){
      this.loadingPost = true //se morirá cuando se vuelva a abrir el componente, espero :u
      this.$emit('next',{ idCoordinador: this.coor.idCoordinador })
    },
    deleteCoor(){
      this.coor = null
    },
    captureCoor(value){ //value = {codigo, idCoordinador, nombres}
      this.coor = value
    },
    async searchCoor(value){
      this.loading = true
      try{
        let { data: { data } } = await this.$api.getCoordinators(value)
        this.items = data
      } catch(e){
        this.$store.commit('setError', e)
      }
      this.loading = false
    },
  },
  computed:{
    valid(){
      return this.coor != null
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
